      namespace std {
         typedef long unsigned int size_t;
         typedef long int ptrdiff_t;
       }
        extern "C++" 
       int atoi(const char *);
       
        namespace std __attribute__ (()) {
         template<typename _Tp, _Tp __v>     struct integral_constant     {
            static constexpr _Tp value = __v;
            typedef integral_constant type;
          };
         typedef integral_constant<bool, true> true_type;
         typedef integral_constant<bool, false> false_type;
         template<bool __v>     using __bool_constant = integral_constant<bool, __v>;
         template<typename...>     struct __or_;
         template<typename _Pp>     struct __not_     : public __bool_constant<!bool()>     {};
         template<typename _Tp>     struct __success_type     {
      typedef _Tp type;
      };
         template<typename>     struct remove_cv;
         template<typename>     struct __is_void_helper     : public false_type {};
         template<typename _Tp>     struct is_void     : public __is_void_helper<typename remove_cv<_Tp>::type>::type     {};
         template<typename>     struct is_array     : public false_type {};
         template<typename>     struct is_lvalue_reference     : public false_type {};
         template<typename>     struct is_rvalue_reference     : public false_type {};
         template<typename>     struct is_function;
         template<typename>     struct __is_member_object_pointer_helper     : public false_type {};
         template<typename _Tp>     struct is_member_object_pointer     : public __is_member_object_pointer_helper<     typename remove_cv<_Tp>::type>::type     {};
         template<typename>     struct __is_member_function_pointer_helper     : public false_type {};
         template<typename _Tp>     struct is_member_function_pointer     : public __is_member_function_pointer_helper<     typename remove_cv<_Tp>::type>::type     {};
         template<typename _Tp>     struct is_reference     : public __or_<is_lvalue_reference<_Tp>,                    is_rvalue_reference<_Tp>>::type     {};
         template<typename _Tp>     struct is_object     : public __not_<__or_<>>::type     {};
         template<typename _Tp>     struct __is_referenceable     : public __or_<is_object<_Tp>, is_reference<_Tp>>::type     {};
         template<typename _Tp, typename _Up = _Tp&&>     _Up     __declval(int);
         template<typename _Tp>     auto declval() noexcept -> decltype(__declval<_Tp>(0));
         template<typename _Tp, bool = __is_referenceable<_Tp>::value>     struct __is_nt_move_assignable_impl;
         template<typename _Tp>     struct is_nothrow_move_assignable     : public __is_nt_move_assignable_impl<_Tp>     {};
         template<typename _Tp>     struct remove_const     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_volatile     {
      typedef _Tp type;
      };
         template<typename _Tp>     struct remove_cv     {
            typedef typename       remove_const<typename remove_volatile<_Tp>::type>::type type;
          };
         template<typename _Tp>     struct remove_reference     {
      typedef _Tp type;
      };
         template<typename _Signature>     class result_of;
         struct __invoke_memobj_deref ;
         struct __invoke_other ;
         template<typename _Tp, typename _Tag>     struct __result_of_success : __success_type<_Tp>     {};
         template<bool, bool, typename _Functor, typename... _ArgTypes>     struct __result_of_impl     ;
         struct __result_of_other_impl   {
          template<typename _Fn, typename... _Args>       static __result_of_success<decltype(       std::declval<_Fn>()(std::declval<_Args>()...)       ), __invoke_other> _S_test(int);
        };
         template<typename _Functor, typename... _ArgTypes>     struct __result_of_impl<false, false, _Functor, _ArgTypes...>     : private __result_of_other_impl     {
            typedef decltype(_S_test<_Functor, _ArgTypes...>(0)) type;
          };
         template<typename _Functor, typename... _ArgTypes>     struct __invoke_result     : public __result_of_impl<         is_member_object_pointer<           typename remove_reference<_Functor>::type         >::value,         is_member_function_pointer<           typename remove_reference<_Functor>::type         >::value,  _Functor, _ArgTypes...       >::type     {};
         template<typename _Functor, typename... _ArgTypes>     struct result_of<_Functor(_ArgTypes...)>     : public __invoke_result<_Functor, _ArgTypes...>     {};
         template<typename...> using __void_t = void;
         template<typename _Default, typename _AlwaysVoid,     template<typename...> class _Op, typename... _Args>     struct __detector     ;
         template<typename _Fn, typename _Tp>     constexpr bool __call_is_nt     ;
         template<typename _Result, typename _Fn, typename... _Args>     struct __call_is_nothrow     : __bool_constant<  0       >     {};
       }
        
         template<typename _Tp>     class new_allocator     ;
       
        namespace std {}
        namespace std __attribute__ (()) {}
        namespace Eigen {
       const int Dynamic = -1;
       
       const unsigned int RowMajorBit = 0x1;
       const unsigned int EvalBeforeNestingBit = 0x2;
       
       
       const unsigned int LinearAccessBit = 0x10;
       const unsigned int LvalueBit = 0x20;
       const unsigned int DirectAccessBit = 0x40;
       const unsigned int NestByRefBit = 0x100;
       const unsigned int HereditaryBits = RowMajorBit                                   | EvalBeforeNestingBit;
       enum UpLoType {};
       enum DirectionType {
        DefaultTraversal,   LinearTraversal,   InnerVectorizedTraversal,   LinearVectorizedTraversal,   SliceVectorizedTraversal,       };
       enum UnrollingType {
        NoUnrolling,      CompleteUnrolling };
       enum SpecializedType {
        Specialized,    };
       enum StorageOptions {
           RowMajor ,   AutoAlign ,    };
       enum NoChange_t {
        ReadOnlyAccessors,   WriteAccessors,   DirectAccessors,   DirectWriteAccessors };
       struct Dense ;
       struct MatrixXpr ;
       struct DenseShape ;
       namespace internal {
      struct IndexBased ;
      }
       typedef std::ptrdiff_t Index;
       namespace internal {
      template<bool Condition, typename Then, typename Else> struct conditional {
     typedef Then type;
     };
      template<typename Then, typename Else> struct conditional <false, Then, Else> {
     typedef Else type;
     };
      template<typename T, typename U> struct is_same ;
      template<typename T> struct is_same<T,T> {
     enum {
    value = 1 };
     };
      template<typename T> struct remove_reference {
     typedef T type;
     };
      template<typename T> struct remove_reference<T&> {
     typedef T type;
     };
      template<typename T> struct remove_all {
     typedef T type;
     };
      template<typename T> struct is_arithmetic {
     enum {
    value  };
     };
      template <typename T> struct is_const ;
      template<typename T> struct add_const_on_value_type ;
      template<bool Condition, typename T=void> struct enable_if;
      template<typename T> struct enable_if<true,T> {
     typedef T type;
     };
      class noncopyable {};
      template<typename T> struct result_of {
       typedef typename std::result_of<T>::type type1;
       typedef typename remove_all<type1>::type type;
     };
      struct meta_yes {};
      struct meta_no ;
      template <typename T> struct has_ReturnType {
       template <typename C> static meta_yes testFunctor(typename C::ReturnType const *);
       enum {
    value = sizeof(testFunctor<T>(0)) == sizeof(meta_yes) };
     };
      template<typename T> const T* return_ptr;
      template <typename T, typename IndexType=Index> struct has_nullary_operator {
       template <typename C> static meta_yes testFunctor(C const *,typename enable_if<(sizeof(0)>0)>::type * = 0);
       enum {
    value = sizeof(testFunctor(static_cast<T*>(0))) == sizeof(meta_yes) };
     };
      template <typename T, typename IndexType=Index> struct has_unary_operator {
       static meta_no testFunctor;
       enum {
    value  };
     };
      template <typename T, typename IndexType=Index> struct has_binary_operator {
       static meta_no testFunctor;
       enum {
    value  };
     };
      template<typename T, typename U> struct scalar_product_traits ;
      template<typename T> struct traits;
      template<typename T> struct traits<const T> : traits<T> {};
      template<typename Derived> struct has_direct_access ;
      template<typename Derived> struct accessors_level {
       enum {
    has_direct_access ,          has_write_access ,          value = (has_write_access ? DirectWriteAccessors : DirectAccessors)   };
     };
      template<typename T> struct evaluator_traits;
      template< typename T> struct evaluator;
      }
       template<typename Derived> struct EigenBase;
       template<typename Derived> class PlainObjectBase;
       template<typename Derived,          int Level = internal::accessors_level<Derived>::value > class DenseCoeffsBase;
       template<typename _Scalar, int _Rows, int _Cols,          int _Options = AutoAlign |                           0,          int _MaxRows = _Rows,          int _MaxCols = _Cols > class Matrix;
       template<typename Derived> class MatrixBase;
       template<typename MatrixType> class Transpose;
       template<typename NullaryOp, typename MatrixType> class CwiseNullaryOp;
       template<typename BinaryOp, typename Lhs, typename Rhs> class CwiseBinaryOp;
       template<typename XprType> class InnerIterator;
       namespace internal {
      template<typename LhsScalar, typename RhsScalar, bool ConjLhs=false, bool ConjRhs=false> struct conj_helper;
      template<typename Scalar> struct scalar_constant_op;
      template<typename LhsScalar,typename RhsScalar=LhsScalar> struct scalar_product_op;
      }
       template<typename _Scalar, int _Rows, int _Cols,          int _Options = AutoAlign |                           0,          int _MaxRows = _Rows, int _MaxCols = _Cols> class Array;
       namespace internal {}
       }
        namespace Eigen {
       namespace internal {
      template<typename ExprScalar,typename T, bool IsSupported> struct promote_scalar_arg;
      template<typename S,typename T> struct promote_scalar_arg<S,T,true> {
       typedef T type;
     };
      class no_assignment_operator {};
      template<typename I1, typename I2> struct promote_index_type ;
      template<typename T, int Value> class variable_if_dynamic {
       public:     
         inline explicit variable_if_dynamic(T v) {}
         static inline T value() ;
     };
      template<typename T> struct functor_traits ;
      template<typename T> struct packet_traits;
      template<typename T> struct unpacket_traits {
       typedef T half;
       enum   {};
     };
      template<int Size, typename PacketType,          bool Stop = Size==Dynamic || 0==0 || is_same<PacketType,typename unpacket_traits<PacketType>::half>::value> struct find_best_packet_helper;
      template< int Size, typename PacketType> struct find_best_packet_helper<Size,PacketType,true> {
       typedef PacketType type;
     };
      template<typename T, int Size> struct find_best_packet {
       typedef typename find_best_packet_helper<Size,typename packet_traits<T>::type>::type type;
     };
      template<int ArrayBytes, int AlignmentBytes> struct compute_default_alignment_helper ;
      template<typename T, int Size> struct compute_default_alignment {
       enum {
    value  };
     };
      template<typename Scalar, int Rows, int Cols, int Options, int MaxRows, int MaxCols> class compute_matrix_flags {
         enum {
    row_major_bit  };
       public:     enum {
    ret = DirectAccessBit | LvalueBit | NestByRefBit | row_major_bit };
     };
      template<int _Rows, int _Cols> struct size_at_compile_time ;
      template<typename XprType> struct size_of_xpr_at_compile_time ;
      template <typename T> struct ref_selector {
       typedef typename conditional<     bool(traits<T>::Flags & NestByRefBit),     T const&,     const T   >::type type;
     };
      template<typename Derived, typename XprKind = typename traits<Derived>::XprKind> struct dense_xpr_base {
       typedef MatrixBase<Derived> type;
     };
      template<typename Derived, typename XprKind = typename traits<Derived>::XprKind, typename StorageKind = typename traits<Derived>::StorageKind> struct generic_xpr_base;
      template<typename Derived, typename XprKind> struct generic_xpr_base<Derived, XprKind, Dense> {
       typedef typename dense_xpr_base<Derived,XprKind>::type type;
     };
      template <typename A, typename B, typename Functor> struct cwise_promote_storage_type;
      template <typename A, typename Functor> struct cwise_promote_storage_type<A,A,Functor> {
     typedef A ret;
     };
      template <typename LhsKind, typename RhsKind, int LhsOrder, int RhsOrder> struct cwise_promote_storage_order ;
      template<typename Expr,typename Scalar = typename Expr::Scalar> struct plain_constant_type {
       enum {
    Options  };
       typedef Array<Scalar, traits<Expr>::RowsAtCompileTime, traits<Expr>::ColsAtCompileTime,                 Options, traits<Expr>::MaxRowsAtCompileTime,traits<Expr>::MaxColsAtCompileTime> array_type;
       typedef Matrix<Scalar, traits<Expr>::RowsAtCompileTime, traits<Expr>::ColsAtCompileTime,                  Options, traits<Expr>::MaxRowsAtCompileTime,traits<Expr>::MaxColsAtCompileTime> matrix_type;
       typedef CwiseNullaryOp<scalar_constant_op<Scalar>, const typename conditional<is_same< typename traits<Expr>::XprKind, MatrixXpr >::value, matrix_type, array_type>::type > type;
     };
      template<typename ExpressionType> struct is_lvalue ;
      }
       template<typename ScalarA, typename ScalarB, typename BinaryOp=internal::scalar_product_op<ScalarA,ScalarB> > struct ScalarBinaryOpTraits   : internal::scalar_product_traits<ScalarA,ScalarB> {};
       template<typename T, typename BinaryOp> struct ScalarBinaryOpTraits<T,T,BinaryOp> {
        typedef T ReturnType;
      };
       template<typename T> struct GenericNumTraits ;
       template<typename T> struct NumTraits : GenericNumTraits<T> {};
       namespace internal {
      struct default_packet_traits {};
      template<typename T> struct packet_traits : default_packet_traits {
       typedef T type;
       enum {};
     };
      
      template<typename Packet> inline Packet pmul(const Packet& a,         const Packet& b) {
     return a*b;
     }
      template<typename Arg1, typename Arg2> struct binary_op_base {};
      template<typename LhsScalar,typename RhsScalar> struct scalar_sum_op : binary_op_base<LhsScalar,RhsScalar> {
       typedef typename ScalarBinaryOpTraits<LhsScalar,RhsScalar,scalar_sum_op>::ReturnType result_type;
       inline const result_type operator() (const LhsScalar& a, const RhsScalar& b) const {
    return a + b;
    }
     };
      template<typename LhsScalar,typename RhsScalar> struct scalar_product_op : binary_op_base<LhsScalar,RhsScalar> {
       typedef typename ScalarBinaryOpTraits<LhsScalar,RhsScalar,scalar_product_op>::ReturnType result_type;
       inline const result_type operator() (const LhsScalar& a, const RhsScalar& b) const {
    return a * b;
    }
     };
      template<typename LhsScalar,typename RhsScalar> struct scalar_conj_product_op : binary_op_base<LhsScalar,RhsScalar> {
       enum {
        Conj    };
       typedef typename ScalarBinaryOpTraits<LhsScalar,RhsScalar,scalar_conj_product_op>::ReturnType result_type;
       inline const result_type operator() (const LhsScalar& a, const RhsScalar& b) const   {
    return conj_helper<LhsScalar,RhsScalar,Conj,false>().pmul(a,b);
    }
     };
      template<typename Scalar> struct scalar_constant_op {
       inline scalar_constant_op(const Scalar& other) : m_other(other) {}
       inline const Scalar operator() () const {
    return m_other;
    }
       const Scalar m_other;
     };
      template<typename Functor> struct functor_has_linear_access {
     enum {
    ret = !has_binary_operator<Functor>::value };
     };
      }
       }
        namespace Eigen {
       namespace internal {
      template<typename DstScalar,typename SrcScalar> struct add_assign_op {
       inline void assignCoeff(DstScalar& a, const SrcScalar& b) const {
    a += b;
    }
     };
      template<typename T> struct add_const_on_value_type_if_arithmetic ;
      }
       template<typename Derived> class DenseCoeffsBase<Derived,ReadOnlyAccessors> : public EigenBase<Derived> {
        public:     typedef typename internal::traits<Derived>::StorageKind StorageKind;
          typedef typename internal::traits<Derived>::Scalar Scalar;
          typedef typename internal::conditional<bool(internal::traits<Derived>::Flags&LvalueBit),                          const Scalar&,                          typename internal::conditional<internal::is_arithmetic<Scalar>::value, Scalar, const Scalar>::type                      >::type CoeffReturnType;
      };
       template<typename Derived> class DenseCoeffsBase<Derived, WriteAccessors> : public DenseCoeffsBase<Derived, ReadOnlyAccessors> {};
       template<typename Derived> class DenseCoeffsBase<Derived, DirectWriteAccessors>   : public DenseCoeffsBase<Derived, WriteAccessors> {};
       namespace internal {}
       template<typename Derived> class DenseBase   : public DenseCoeffsBase<Derived> {
        public:     typedef Eigen::InnerIterator<Derived> InnerIterator;
          typedef typename internal::traits<Derived>::Scalar Scalar;
          typedef DenseCoeffsBase<Derived> Base;
          using Base::derived;
          enum {
           RowsAtCompileTime ,       ColsAtCompileTime ,       SizeAtCompileTime ,       MaxRowsAtCompileTime ,       MaxColsAtCompileTime ,       MaxSizeAtCompileTime ,       IsVectorAtCompileTime = internal::traits<Derived>::MaxRowsAtCompileTime == 1                            || internal::traits<Derived>::MaxColsAtCompileTime == 1,       Flags ,       IsRowMajor = int(Flags) & RowMajorBit,       InnerSizeAtCompileTime = int() ? int()                              : int(IsRowMajor) ? int(ColsAtCompileTime) : int(),                   };
          Scalar sum() const;
          template<typename BinaryOp>     Scalar redux(const BinaryOp& func) const;
      };
       }
        namespace Eigen {
       template<typename Derived> class MatrixBase   : public DenseBase<Derived> {
        public:     typedef MatrixBase StorageBaseType;
          typedef typename internal::traits<Derived>::Scalar Scalar;
          typedef DenseBase<Derived> Base;
          using Base::derived;
      template<typename CustomBinaryOp, typename OtherDerived> inline const CwiseBinaryOp<CustomBinaryOp, const Derived, const OtherDerived> binaryExpr(const Eigen::MatrixBase<OtherDerived> &other) const {
       const CustomBinaryOp & func = CustomBinaryOp();
       return CwiseBinaryOp<CustomBinaryOp, const Derived, const OtherDerived>(derived(), other.derived(), func);
     }
      template <typename T> inline friend typename internal::enable_if<true,const CwiseBinaryOp<internal::scalar_product_op<typename internal::promote_scalar_arg<Scalar , T , (Eigen::internal::has_ReturnType<Eigen::ScalarBinaryOpTraits<T,Scalar,Eigen::internal::scalar_product_op<T,Scalar> > >::value)>::type,typename internal::traits<Derived>::Scalar>, const typename internal::plain_constant_type<Derived,typename internal::promote_scalar_arg<Scalar , T , (Eigen::internal::has_ReturnType<Eigen::ScalarBinaryOpTraits<T,Scalar,Eigen::internal::scalar_product_op<T,Scalar> > >::value)>::type>::type, const Derived> >::type (operator*)(const T& scalar, const StorageBaseType& matrix) {
     typedef typename internal::promote_scalar_arg<Scalar,T,(Eigen::internal::has_ReturnType<Eigen::ScalarBinaryOpTraits<T,Scalar,Eigen::internal::scalar_product_op<T,Scalar> > >::value)>::type PromotedT;
     return CwiseBinaryOp<internal::scalar_product_op<PromotedT,typename internal::traits<Derived>::Scalar>, const typename internal::plain_constant_type<Derived,PromotedT>::type, const Derived>( typename internal::plain_constant_type<Derived,PromotedT>::type(0, 0, internal::scalar_constant_op<PromotedT>(scalar)), matrix.derived());
     }
          template<typename OtherDerived>     inline     Derived& operator+=(const MatrixBase<OtherDerived>& other);
          template<typename OtherDerived>     typename ScalarBinaryOpTraits<typename internal::traits<Derived>::Scalar,typename internal::traits<OtherDerived>::Scalar>::ReturnType     dot(const MatrixBase<OtherDerived>& other) const;
      };
       template<typename Derived> struct EigenBase {
        Derived& derived() {
     return *static_cast<Derived*>(this);
     }
        const Derived& derived() const {
     return *static_cast<const Derived*>(this);
     }
        inline Derived& const_cast_derived() const   {
     return *static_cast<Derived*>(const_cast<EigenBase*>(this));
     }
      };
       namespace internal {
      template<typename StorageKind> struct storage_kind_to_evaluator_kind {
       typedef IndexBased Kind;
     };
      template<typename StorageKind> struct storage_kind_to_shape;
      template<> struct storage_kind_to_shape<Dense> {
     typedef DenseShape Shape;
     };
      template< typename T,           typename LhsKind = typename evaluator_traits<typename T::Lhs>::Kind,           typename RhsKind = typename evaluator_traits<typename T::Rhs>::Kind,           typename LhsScalar = typename traits<typename T::Lhs>::Scalar,           typename RhsScalar = typename traits<typename T::Rhs>::Scalar> struct binary_evaluator;
      template<typename T> struct evaluator_traits_base {
       typedef typename storage_kind_to_evaluator_kind<typename traits<T>::StorageKind>::Kind Kind;
       typedef typename storage_kind_to_shape<typename traits<T>::StorageKind>::Shape Shape;
     };
      template<typename T> struct evaluator_traits : public evaluator_traits_base<T> {};
      template<typename T, typename Shape = typename evaluator_traits<T>::Shape > struct evaluator_assume_aliasing {
       static const bool value = false;
     };
      template<typename T> struct evaluator<const T>   : evaluator<T> {
       explicit evaluator(const T& xpr) : evaluator<T>(xpr) {}
     };
      template<typename ExpressionType> struct evaluator_base : public noncopyable {};
      template<typename Derived> struct evaluator<PlainObjectBase<Derived> >   : evaluator_base<Derived> {
       typedef PlainObjectBase<Derived> PlainObjectType;
       typedef typename PlainObjectType::Scalar Scalar;
       typedef typename PlainObjectType::CoeffReturnType CoeffReturnType;
       enum {
        IsRowMajor ,     IsVectorAtCompileTime ,     RowsAtCompileTime ,     ColsAtCompileTime ,     CoeffReadCost ,     Flags = traits<Derived>::EvaluatorFlags,     Alignment    };
       explicit evaluator(const PlainObjectType& m)     : m_data(m.data()), m_outerStride(IsVectorAtCompileTime ? 0 : 0)   {}
       inline   CoeffReturnType coeff(Index row, Index col) const   {
        if (IsRowMajor)       return m_data[row * 0 + col];
        else       return m_data[row + col * 0];
      }
       inline   CoeffReturnType coeff(Index index) const   {
        return m_data[index];
      }
       inline   Scalar& coeffRef(Index index)   {
        return const_cast<Scalar*>(m_data)[index];
      }
     protected:   const Scalar *m_data;
       variable_if_dynamic<Index, IsVectorAtCompileTime ? 0                                                     : int() ? ColsAtCompileTime                                                     : RowsAtCompileTime> m_outerStride;
     };
      template<typename Scalar, int Rows, int Cols, int Options, int MaxRows, int MaxCols> struct evaluator<Matrix<Scalar, Rows, Cols, Options, MaxRows, MaxCols> >   : evaluator<PlainObjectBase<Matrix<Scalar, Rows, Cols, Options, MaxRows, MaxCols> > > {
       typedef Matrix<Scalar, Rows, Cols, Options, MaxRows, MaxCols> XprType;
       explicit evaluator(const XprType& m)     : evaluator<PlainObjectBase<XprType> >(m)   {}
     };
      template<typename Scalar,typename NullaryOp,          bool has_nullary = has_nullary_operator<NullaryOp>::value,          bool has_unary = has_unary_operator<NullaryOp>::value,          bool has_binary = has_binary_operator<NullaryOp>::value> struct nullary_wrapper ;
      template<typename Scalar,typename NullaryOp> struct nullary_wrapper<Scalar,NullaryOp,true,false,false> {
       template <typename IndexType>   inline Scalar operator()(const NullaryOp& op, IndexType=0, IndexType=0) const {
    return op();
    }
     };
      template<typename NullaryOp, typename PlainObjectType> struct evaluator<CwiseNullaryOp<NullaryOp,PlainObjectType> >   : evaluator_base<CwiseNullaryOp<NullaryOp,PlainObjectType> > {
       typedef CwiseNullaryOp<NullaryOp,PlainObjectType> XprType;
       typedef typename internal::remove_all<PlainObjectType>::type PlainObjectTypeCleaned;
       enum {
        CoeffReadCost ,     Flags = (evaluator<PlainObjectTypeCleaned>::Flags           & ( HereditaryBits               | (functor_has_linear_access<NullaryOp>::ret ? LinearAccessBit : 0)               | 0))           | 0,        };
       explicit evaluator(const XprType& n)     : m_functor(n.functor()), m_wrapper()   {}
       typedef typename XprType::CoeffReturnType CoeffReturnType;
       template <typename IndexType>   inline   CoeffReturnType coeff(IndexType index) const   {
        return m_wrapper(m_functor,index);
      }
     protected:   const NullaryOp m_functor;
       const internal::nullary_wrapper<CoeffReturnType,NullaryOp> m_wrapper;
     };
      template<typename BinaryOp, typename Lhs, typename Rhs> struct evaluator<CwiseBinaryOp<BinaryOp, Lhs, Rhs> >   : public binary_evaluator<CwiseBinaryOp<BinaryOp, Lhs, Rhs> > {
       typedef CwiseBinaryOp<BinaryOp, Lhs, Rhs> XprType;
       typedef binary_evaluator<CwiseBinaryOp<BinaryOp, Lhs, Rhs> > Base;
       explicit evaluator(const XprType& xpr) : Base(xpr) {}
     };
      template<typename BinaryOp, typename Lhs, typename Rhs> struct binary_evaluator<CwiseBinaryOp<BinaryOp, Lhs, Rhs>, IndexBased, IndexBased>   : evaluator_base<CwiseBinaryOp<BinaryOp, Lhs, Rhs> > {
       typedef CwiseBinaryOp<BinaryOp, Lhs, Rhs> XprType;
       enum {
        CoeffReadCost ,     LhsFlags = evaluator<Lhs>::Flags,     RhsFlags ,          StorageOrdersAgree = 0==0,     Flags0 = (int() | int()) & (         HereditaryBits       | (int() & int() &            ( (StorageOrdersAgree ? LinearAccessBit : 0)            | 0            )         )      ),     Flags ,     Alignment    };
       explicit binary_evaluator(const XprType& xpr)     : m_functor(),       m_lhsImpl(xpr.lhs()),       m_rhsImpl(xpr.rhs())   {}
       typedef typename XprType::CoeffReturnType CoeffReturnType;
       inline   CoeffReturnType coeff(Index row, Index col) const   {
        return m_functor(m_lhsImpl.coeff(row, col), m_rhsImpl.coeff(row, col));
      }
       inline   CoeffReturnType coeff(Index index) const   {
        return m_functor(m_lhsImpl.coeff(index), m_rhsImpl.coeff(index));
      }
     protected:   const BinaryOp m_functor;
       evaluator<Lhs> m_lhsImpl;
       evaluator<Rhs> m_rhsImpl;
     };
      }
       namespace internal {
      template <typename DstEvaluator, typename SrcEvaluator, typename AssignFunc> struct copy_using_evaluator_traits {
       typedef typename DstEvaluator::XprType Dst;
       typedef typename Dst::Scalar DstScalar;
       enum {
        DstFlags = DstEvaluator::Flags,     SrcFlags = SrcEvaluator::Flags   };
     public:   enum {
                  DstHasDirectAccess ,        };
     private:   enum {
        InnerSize ,          OuterStride ,        };
       typedef typename find_best_packet<DstScalar,Dst::SizeAtCompileTime>::type LinearPacketType;
       typedef typename find_best_packet<DstScalar,InnerSize>::type InnerPacketType;
       enum {
        LinearPacketSize ,     InnerPacketSize    };
     public:   enum {};
     private:   enum {
        DstIsRowMajor ,     SrcIsRowMajor = SrcFlags&RowMajorBit,     StorageOrdersAgree ,     MightVectorize ,     MayInnerVectorize = MightVectorize                        && int()!=Dynamic && int()%int(InnerPacketSize)==0                        && int()!=Dynamic && int()%int(InnerPacketSize)==0                        && 0,     MayLinearize ,     MayLinearVectorize = bool() && bool() && bool()                        && 0,     MaySliceVectorize = bool() && bool()                        && 0   };
     public:   enum {
        Traversal = int() && 0 ? int()               : int() ? int()               : int() ? int()               : int() ? int()               : int(MayLinearize) ? int(LinearTraversal)                                          : int(),     Vectorized = int() == InnerVectorizedTraversal               || int() == LinearVectorizedTraversal               || int() == SliceVectorizedTraversal   };
     private:   enum {
        ActualPacketSize ,     UnrollingLimit ,     MayUnrollCompletely = int() != Dynamic                        && int() * 0 <= int(),        };
     public:   enum {
        Unrolling = 0                 ? 0               : int() == int(LinearVectorizedTraversal)                 ? 0               : int(Traversal) == int(LinearTraversal)                 ? ( bool(MayUnrollCompletely) ? int(CompleteUnrolling)                                               : int() )               : int() == int()                 ? 0               : int()   };
     };
      template<typename Kernel, int Index, int Stop> struct copy_using_evaluator_LinearTraversal_CompleteUnrolling {
       static inline void run(Kernel& kernel)   {
        kernel.assignCoeff(Index);
        copy_using_evaluator_LinearTraversal_CompleteUnrolling<Kernel, Index+1, Stop>::run(kernel);
      }
     };
      template<typename Kernel, int Stop> struct copy_using_evaluator_LinearTraversal_CompleteUnrolling<Kernel, Stop, Stop> {
       static inline void run(Kernel&) {}
     };
      template<typename Kernel,          int Traversal = Kernel::AssignmentTraits::Traversal,          int Unrolling = Kernel::AssignmentTraits::Unrolling> struct dense_assignment_loop;
      template<typename Kernel> struct dense_assignment_loop<Kernel, LinearTraversal, CompleteUnrolling> {
       static inline void run(Kernel &kernel)   {
        typedef typename Kernel::DstEvaluatorType::XprType DstXprType;
        copy_using_evaluator_LinearTraversal_CompleteUnrolling<Kernel, 0, DstXprType::SizeAtCompileTime>::run(kernel);
      }
     };
      template<typename DstEvaluatorTypeT, typename SrcEvaluatorTypeT, typename Functor, int Version = Specialized> class generic_dense_assignment_kernel {
     protected:   typedef typename DstEvaluatorTypeT::XprType DstXprType;
     public:   typedef DstEvaluatorTypeT DstEvaluatorType;
       typedef SrcEvaluatorTypeT SrcEvaluatorType;
       typedef copy_using_evaluator_traits<DstEvaluatorTypeT, SrcEvaluatorTypeT, Functor> AssignmentTraits;
       generic_dense_assignment_kernel(DstEvaluatorType &dst, const SrcEvaluatorType &src, const Functor &func, DstXprType& dstExpr)     : m_dst(dst), m_src(src), m_functor(func), m_dstExpr(dstExpr)   {}
       inline void assignCoeff(Index index)   {
        m_functor.assignCoeff(m_dst.coeffRef(index), m_src.coeff(index));
      }
     protected:   DstEvaluatorType& m_dst;
       const SrcEvaluatorType& m_src;
       const Functor &m_functor;
       DstXprType& m_dstExpr;
     };
      
      template<typename DstXprType, typename SrcXprType, typename Functor>  inline void call_dense_assignment_loop(DstXprType& dst, const SrcXprType& src, const Functor &func) {
       typedef evaluator<DstXprType> DstEvaluatorType;
       typedef evaluator<SrcXprType> SrcEvaluatorType;
       SrcEvaluatorType srcEvaluator(src);
       DstEvaluatorType dstEvaluator(dst);
       typedef generic_dense_assignment_kernel<DstEvaluatorType,SrcEvaluatorType,Functor> Kernel;
       Kernel kernel(dstEvaluator, srcEvaluator, func, dst.const_cast_derived());
       dense_assignment_loop<Kernel>::run(kernel);
     }
      struct Dense2Dense ;
      struct EigenBase2EigenBase ;
      template<typename,typename> struct AssignmentKind ;
      template<> struct AssignmentKind<DenseShape,DenseShape> {
     typedef Dense2Dense Kind;
     };
      template< typename DstXprType, typename SrcXprType, typename Functor,           typename Kind = typename AssignmentKind< typename evaluator_traits<DstXprType>::Shape , typename evaluator_traits<SrcXprType>::Shape >::Kind,           typename EnableIf = void> struct Assignment;
      template<typename Dst, typename Src, typename Func>  inline void call_assignment(Dst& dst, const Src& src, const Func& func) {
       enum {
        NeedToTranspose    };
       typedef typename internal::conditional<NeedToTranspose, Transpose<Dst>, Dst>::type ActualDstTypeCleaned;
       typedef typename internal::conditional<NeedToTranspose, Transpose<Dst>, Dst&>::type ActualDstType;
       ActualDstType actualDst(dst);
       Assignment<ActualDstTypeCleaned,Src,Func>::run(actualDst, src, func);
     }
      template< typename DstXprType, typename SrcXprType, typename Functor, typename Weak> struct Assignment<DstXprType, SrcXprType, Functor, Dense2Dense, Weak> {
       static inline void run(DstXprType &dst, const SrcXprType &src, const Functor &func)   {
        call_dense_assignment_loop(dst, src, func);
      }
     };
      template<typename Scalar> struct conj_helper<Scalar,Scalar,false,false> {
       inline Scalar pmul(const Scalar& x, const Scalar& y) const {
    return internal::pmul(x,y);
    }
     };
      }
       namespace internal {
      struct constructor_without_unaligned_array_assert ;
      template <typename T, int Size, int MatrixOrArrayOptions,           int Alignment = 0 ? 0                         : compute_default_alignment<T,Size>::value > struct plain_array {
       T array[Size];
     };
      }
       template<typename T, int Size, int _Rows, int _Cols, int _Options> class DenseStorage {
          internal::plain_array<T,Size,_Options> m_data;
        public:     DenseStorage() ;
          DenseStorage(const DenseStorage& other) : m_data(other.m_data) {}
          static Index rows ;
          static Index cols ;
          const T *data() const {
     return m_data.array;
     }
      };
       namespace internal {}
       template<typename Derived> class PlainObjectBase : public internal::dense_xpr_base<Derived>::type {
        public:     enum {
     Options  };
          typedef typename internal::dense_xpr_base<Derived>::type Base;
          typedef typename internal::traits<Derived>::Scalar Scalar;
          using Base::SizeAtCompileTime;
        protected:     DenseStorage<Scalar, Base::MaxSizeAtCompileTime, Base::RowsAtCompileTime, Base::ColsAtCompileTime, Options> m_storage;
        public:     enum {};
          inline Index rows() const ;
          inline Index cols() const ;
          inline const Scalar *data() const     {
     return m_storage.data();
     }
      };
       namespace internal {
      template<typename _Scalar, int _Rows, int _Cols, int _Options, int _MaxRows, int _MaxCols> struct traits<Matrix<_Scalar, _Rows, _Cols, _Options, _MaxRows, _MaxCols> > {
     private:   enum {
    size  };
       typedef typename find_best_packet<_Scalar,size>::type PacketScalar;
       enum {};
     public:   typedef _Scalar Scalar;
       typedef Dense StorageKind;
       typedef MatrixXpr XprKind;
       enum {
        RowsAtCompileTime ,     ColsAtCompileTime ,     MaxRowsAtCompileTime ,     MaxColsAtCompileTime ,     Flags = compute_matrix_flags<_Scalar, _Rows, _Cols, _Options, _MaxRows, _MaxCols>::ret,     Options ,               EvaluatorFlags ,     Alignment    };
     };
      }
       template<typename _Scalar, int _Rows, int _Cols, int _Options, int _MaxRows, int _MaxCols> class Matrix   : public PlainObjectBase<Matrix<_Scalar, _Rows, _Cols, _Options, _MaxRows, _MaxCols> > {
        public:     typedef PlainObjectBase<Matrix> Base;
      typedef typename Eigen::internal::ref_selector<Matrix>::type Nested;
      };
       namespace internal {
      template<typename BinaryOp, typename Lhs, typename Rhs> struct traits<CwiseBinaryOp<BinaryOp, Lhs, Rhs> > {
       typedef typename remove_all<Lhs>::type Ancestor;
       typedef typename traits<Ancestor>::XprKind XprKind;
       enum {
        RowsAtCompileTime ,     ColsAtCompileTime ,     MaxRowsAtCompileTime ,     MaxColsAtCompileTime    };
       typedef typename result_of<                      BinaryOp(                        const typename Lhs::Scalar&,                        const typename Rhs::Scalar&                      )                    >::type Scalar;
       typedef typename cwise_promote_storage_type<typename traits<Lhs>::StorageKind,                                               typename traits<Rhs>::StorageKind,                                               BinaryOp>::ret StorageKind;
       typedef typename Lhs::Nested LhsNested;
       typedef typename Rhs::Nested RhsNested;
       typedef typename remove_reference<LhsNested>::type _LhsNested;
       typedef typename remove_reference<RhsNested>::type _RhsNested;
       enum {
        Flags    };
     };
      }
       template<typename BinaryOp, typename Lhs, typename Rhs, typename StorageKind> class CwiseBinaryOpImpl;
       template<typename BinaryOp, typename LhsType, typename RhsType> class CwiseBinaryOp :   public CwiseBinaryOpImpl<           BinaryOp, LhsType, RhsType,           typename internal::cwise_promote_storage_type<typename internal::traits<LhsType>::StorageKind,                                                         typename internal::traits<RhsType>::StorageKind,                                                         BinaryOp>::ret>,   internal::no_assignment_operator {
        public:     typedef typename internal::remove_all<BinaryOp>::type Functor;
          typedef typename internal::remove_all<LhsType>::type Lhs;
          typedef typename internal::remove_all<RhsType>::type Rhs;
          typedef typename internal::ref_selector<LhsType>::type LhsNested;
          typedef typename internal::ref_selector<RhsType>::type RhsNested;
          typedef typename internal::remove_reference<LhsNested>::type _LhsNested;
          typedef typename internal::remove_reference<RhsNested>::type _RhsNested;
          inline CwiseBinaryOp(const Lhs& aLhs, const Rhs& aRhs, const BinaryOp& func = BinaryOp())       : m_lhs(aLhs), m_rhs(aRhs), m_functor()     {}
          const _LhsNested& lhs() const {
     return m_lhs;
     }
          const _RhsNested& rhs() const {
     return m_rhs;
     }
          const BinaryOp& functor() const ;
        protected:     LhsNested m_lhs;
          RhsNested m_rhs;
          const BinaryOp m_functor;
      };
       template<typename BinaryOp, typename Lhs, typename Rhs, typename StorageKind> class CwiseBinaryOpImpl   : public internal::generic_xpr_base<CwiseBinaryOp<BinaryOp, Lhs, Rhs> >::type {};
       template<typename Derived> template<typename OtherDerived> inline Derived & MatrixBase<Derived>::operator+=(const MatrixBase<OtherDerived>& other) {
        call_assignment(derived(), other.derived(), internal::add_assign_op<Scalar,typename OtherDerived::Scalar>());
        return derived();
      }
       }
        namespace Eigen {
       namespace internal {
      template<typename NullaryOp, typename PlainObjectType> struct traits<CwiseNullaryOp<NullaryOp, PlainObjectType> > : traits<PlainObjectType> {
       enum {
        Flags    };
     };
      }
       template<typename NullaryOp, typename PlainObjectType> class CwiseNullaryOp : public internal::dense_xpr_base< CwiseNullaryOp<NullaryOp, PlainObjectType> >::type, internal::no_assignment_operator {
        public:     typedef typename internal::dense_xpr_base<CwiseNullaryOp>::type Base;
      typedef typename Eigen::internal::ref_selector<CwiseNullaryOp>::type Nested;
      enum {
     RowsAtCompileTime , ColsAtCompileTime ,     };
          CwiseNullaryOp(Index rows, Index cols, const NullaryOp& func = NullaryOp())       : m_rows(rows), m_cols(cols), m_functor(func)     {}
          const NullaryOp& functor() const {
     return m_functor;
     }
        protected:     const internal::variable_if_dynamic<Index, RowsAtCompileTime> m_rows;
          const internal::variable_if_dynamic<Index, ColsAtCompileTime> m_cols;
          const NullaryOp m_functor;
      };
       namespace internal {
      template<typename T, typename U,          bool NeedToTranspose = T::IsVectorAtCompileTime                 && U::IsVectorAtCompileTime                 && 0 > struct dot_nocheck {
       typedef scalar_conj_product_op<typename traits<T>::Scalar,typename traits<U>::Scalar> conj_prod;
       typedef typename conj_prod::result_type ResScalar;
       inline   static ResScalar run(const MatrixBase<T>& a, const MatrixBase<U>& b)   {
        return a.template binaryExpr<conj_prod>(b).sum();
      }
     };
      }
       template<typename Derived> template<typename OtherDerived> inline typename ScalarBinaryOpTraits<typename internal::traits<Derived>::Scalar,typename internal::traits<OtherDerived>::Scalar>::ReturnType MatrixBase<Derived>::dot(const MatrixBase<OtherDerived>& other) const {
        return internal::dot_nocheck<Derived,OtherDerived>::run(*this, other);
      }
       namespace internal {
      template<typename Func, typename Derived> struct redux_traits {
     public:     typedef typename find_best_packet<typename Derived::Scalar,Derived::SizeAtCompileTime>::type PacketType;
       enum {
        PacketSize ,     InnerMaxSize    };
       enum {};
     public:   enum {
        Traversal    };
     public:   enum {
        Cost ,     UnrollingLimit    };
     public:   enum {
        Unrolling = Cost <= UnrollingLimit ? CompleteUnrolling : NoUnrolling   };
     };
      template<typename Func, typename Derived, int Start, int Length> struct redux_novec_unroller {
       enum {
        HalfLength = Length/2   };
       typedef typename Derived::Scalar Scalar;
       static inline Scalar run(const Derived &mat, const Func& func)   {
        return func(redux_novec_unroller<Func, Derived, Start, HalfLength>::run(mat,func),                 redux_novec_unroller<Func, Derived, Start+HalfLength, Length-HalfLength>::run(mat,func));
      }
     };
      template<typename Func, typename Derived, int Start> struct redux_novec_unroller<Func, Derived, Start, 1> {
       enum {
        outer = Start / Derived::InnerSizeAtCompileTime,     inner    };
       typedef typename Derived::Scalar Scalar;
       static inline Scalar run(const Derived &mat, const Func&)   {
        return mat.coeffByOuterInner(outer, inner);
      }
     };
      template<typename Func, typename Derived,          int Traversal = redux_traits<Func, Derived>::Traversal,          int Unrolling = redux_traits<Func, Derived>::Unrolling > struct redux_impl;
      template<typename Func, typename Derived> struct redux_impl<Func,Derived, DefaultTraversal, CompleteUnrolling>   : public redux_novec_unroller<Func,Derived, 0, Derived::SizeAtCompileTime> {};
      template<typename _XprType> class redux_evaluator {
     public:   typedef _XprType XprType;
       explicit redux_evaluator(const XprType &xpr) : m_evaluator(xpr), m_xpr(xpr) {}
       typedef typename XprType::Scalar Scalar;
       typedef typename XprType::CoeffReturnType CoeffReturnType;
       enum {
        MaxRowsAtCompileTime ,     MaxColsAtCompileTime ,          IsRowMajor = XprType::IsRowMajor,     SizeAtCompileTime ,     InnerSizeAtCompileTime = XprType::InnerSizeAtCompileTime,     CoeffReadCost ,        };
       CoeffReturnType coeffByOuterInner(Index outer, Index inner) const   {
    return m_evaluator.coeff(IsRowMajor ? outer : inner, IsRowMajor ? inner : outer);
    }
     protected:   internal::evaluator<XprType> m_evaluator;
       const XprType &m_xpr;
     };
      }
       template<typename Derived> template<typename Func> inline typename internal::traits<Derived>::Scalar DenseBase<Derived>::redux(const Func& func) const {
        typedef typename internal::redux_evaluator<Derived> ThisEvaluator;
        ThisEvaluator thisEval(derived());
        return internal::redux_impl<Func, ThisEvaluator>::run(thisEval, func);
      }
       template<typename Derived> inline typename internal::traits<Derived>::Scalar DenseBase<Derived>::sum() const {
        return derived().redux(Eigen::internal::scalar_sum_op<Scalar,Scalar>());
      }
         }
       typedef double T;
        typedef Eigen::Matrix<T, 2, 1> Vec;
        int main (int argc, char const *argv[]) {
         int num = argc > 1 ? atoi(argv[1]) : 100000000;
         Vec sum;
         for (int i = 0;
       i < num;
       ++i)   {
          const Vec dirA = sum;
          const Vec dirB = dirA;
          sum += dirA.dot(dirB) * dirA;
        }
         return static_cast<int>(sum.sum());
       }
